#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "data_entry.h"
#include <unistd.h>
#include <gdk/gdkkeysyms.h>
#include <libpq-fe.h>
#include "pizza_utils.h"
#include "date_setter.h"
#include <time.h>

DataEntry *date_setter = NULL;
static GtkInput *date_from, *the_hour, *the_minute;

enum {
	DS_DATE,
	DS_HOUR,
	DS_MINUTE,

	DS_GO_BTN,
	DS_QUIT_BTN
};


/*----------------------------------------------------------------------------------------------------
::actual reports
----------------------------------------------------------------------------------------------------*/

int theMonth, theDay, theYear, theHour, theMinute;

char *month_names[] = {
	"JAN", "FEB", "MAR",
	"APR", "MAY", "JUN", 
	"JUL", "AUG", "SEP",
	"OCT", "NOV", "DEC", NULL
};

static int get_month (char *ptr)
{
	int i = 0;

	while (month_names[i])
	{
		if (!strncmp (ptr, month_names[i], 3))
			return i+1;
		i++;
	}
	return 0;
}

static int ds_validate ()
{
	char *ptr;

	theMonth = theDay = theYear = theHour = theMinute = 0;

	ptr = gtk_input_get_text (date_from);
	theDay = atoi (ptr);
	while (*ptr && *ptr != ' ') ptr++;
	while (*ptr && *ptr == ' ') ptr++;
	theMonth = get_month (ptr);
	while (*ptr && *ptr != ' ') ptr++;
	while (*ptr && *ptr == ' ') ptr++;
	theYear = atoi(ptr);
	theHour = atoi (gtk_input_get_text (the_hour));
	theMinute = atoi (gtk_input_get_text (the_minute));

	if (theMonth < 1 || theMonth > 12)
	{
	}

	if (theDay < 1 || theDay > 31)
	{
	}

	if (theYear < 1996 || theYear > 2030)
	{
	}

	if (theHour < 1 || theHour > 23)
	{
	}

	if (theMinute < 0 || theMinute > 59)
	{
	}

	return 1;
}

static void ds_go ()
{
	char Buffer[64];

	if (!ds_validate())
		return;

	printf ("Setting new date ...\n");
	sprintf (Buffer, "date %02d%02d%02d%02d%04d", theMonth, theDay, theHour, theMinute, theYear);
	system (Buffer);
}

static void ds_quit ()
{
	gtk_widget_hide (GTK_WIDGET(date_setter));
}

static void ds_default_fields ()
{
	time_t t;
	struct tm *the_tm;
	char Buffer[64];

	t = time(NULL);
	the_tm = localtime (&t);
	sprintf (Buffer, "%02d %s %04d", the_tm->tm_mday, month_names[the_tm->tm_mon], the_tm->tm_year + 1900);
	gtk_input_set_text (date_from, Buffer);
	sprintf (Buffer, "%d", the_tm->tm_hour);
	gtk_input_set_text (the_hour, Buffer);
	sprintf (Buffer, "%d", the_tm->tm_min);
	gtk_input_set_text (the_minute, Buffer);
}

/*----------------------------------------------------------------------------------------------------
::date_setter
----------------------------------------------------------------------------------------------------*/

void do_date_setter ()
{
	if (!date_setter)
	{
	date_setter = DATA_ENTRY(data_entry_new ("Set Date/Time", 420, 20, 0,0));

	date_from = GTK_INPUT(data_entry_add_field (date_setter, DS_DATE, 
		"Current Date:", 16, INPUT_UPPER, 1,1,3,1));
	the_hour = GTK_INPUT(data_entry_add_field (date_setter, DS_HOUR, 
		"Hour:", 3, INPUT_UPPER, 1,2,1,1));
	the_minute = GTK_INPUT(data_entry_add_field (date_setter, DS_MINUTE, 
		"Minute:", 2, INPUT_UPPER, 3,2,1,1));

	data_entry_add_label_button (date_setter, DS_GO_BTN, "Go !", 
		GTK_SIGNAL_FUNC(ds_go), BUTTON_DEFAULT);
	data_entry_add_label_button (date_setter, DS_QUIT_BTN, "Quit", 
		GTK_SIGNAL_FUNC(ds_quit), BUTTON_QUIT);
	}

	if (!GTK_WIDGET_VISIBLE (date_setter))
		gtk_widget_show (GTK_WIDGET(date_setter));

	ds_default_fields ();
	gtk_widget_grab_focus (GTK_WIDGET(date_from));
}
